/**
 * Title:        BCJR with linear approximation
 * Copyright:    Copyright (c) 2001, Ling Li
 * Company:      California Institute of Technology
 * @author Ling Li
 * @email  ling@cs.caltech.edu
 * @version 1.1
 */

package ecc;

public class BCJR_abs extends TurboCode {

    protected double logsum(double x, double y) {
        final double y1 = 0.60650378298995, y2 = 0.43321698784997,
                     y3 = 0.25993019270998, y4 = 0.08664339756999;
        final double d1 = 0.38302943486981, d2 = 0.88137358701954,
                     d3 = 1.66491301734881;

        double m = Math.max(x, y);
        double d = Math.abs(x - y);

        if (d > d3) return m + y4;
        else if (d > d2) return m + y3;
        else if (d > d1) return m + y2;
        else return m + y1;
    }
}