/**
 * Title:        BCJR with ideal log-sum
 * Copyright:    Copyright (c) 2001, Ling Li
 * Company:      California Institute of Technology
 * @author Ling Li
 * @email  ling@cs.caltech.edu
 * @version 1.2
 */

package ecc;

public class BCJR_logsum extends TurboCode {

    protected double logsum(double x, double y) {
        if (Double.isInfinite(x))
            return y;
        else if (Double.isInfinite(y))
            return x;

        double m = Math.max(x, y);
        double d = Math.abs(x - y);

        return m + Math.log(1 + Math.exp(-d));
    }
}