/**
 * Title:        BCJR with square approximation
 * Copyright:    Copyright (c) 2001, Ling Li
 * Company:      California Institute of Technology
 * @author Ling Li
 * @email  ling@cs.caltech.edu
 * @version 1.1
 */

package ecc;

public class BCJR_sqr extends TurboCode {

    protected double logsum(double x, double y) {
        final double y1 = 0.589135, y2 = 0.384049, y3 = 0.192328, y4 = 0.039135;
        final double d1 = 0.467161, d2 = 1.096547, d3 = 2.098058; /**/

        double m = Math.max(x, y);
        double d = Math.abs(x - y);

        if (d > d3) return m + y4;
        else if (d > d2) return m + y3;
        else if (d > d1) return m + y2;
        else return m + y1;
    }
}